# std::unique_ptr::get_deleter

From cppreference.com
< cpp‎ | memory‎ | unique ptr

Deleter& get_deleter(); |  | (since C++11)
const Deleter& get_deleter() const; |  | (since C++11)

Returns the deleter object which would be used for destruction of the managed object.

### Parameters

(none)

### Return value

The stored deleter object.

### Exceptions

`noexcept` specification:
noexcept

### Example

Run this code

    #include <iostream>
    #include <memory>

    struct Foo
    {
        Foo() { std::cout << "Foo...\n"; }
        ~Foo() { std::cout << "~Foo...\n"; }
    };

    struct D
    {
        void bar() { std::cout << "Call deleter D::bar()...\n"; }
        void operator()(Foo* p) const
        {
            std::cout << "Call delete for Foo object...\n";
            delete p;
        }
    };

    int main()
    {
        std::unique_ptr<Foo, D> up(new Foo(), D());
        D& del = up.get_deleter();
        del.bar();
    }

Output:

    Foo...
    Call deleter D::bar()...
    Call delete for Foo object...
    ~Foo...

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/unique_ptr/get_deleter&oldid=91846"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template